<?php

class WorkflowitemModel {
  public $owner_id;
  public $object_type;
  public $active;
  public $required;
  public $name;
  public $label;
  public $description;
  public $type;
  public $typedata;
  public $placeholder;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  

  public static function create(Array $data) {
    $model = new Workflowitem();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("Workflowitem", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Workflowitem($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("Workflowitem", "*", "1=1 ORDER BY num");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Workflowitem($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Workflowitem", "*", "$where ORDER BY num");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Workflowitem($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  

  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    //var_dump($where);exit;
    $res = $db->select("Workflowitem", "*", "$where ORDER BY num");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Workflowitem($data);
      }
    }
    
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";

    //var_dump($filter);exit;
    if(array_key_exists("active", $filter)) {
      $active = $filter['active'];
      if($active == 1) {
        $where .= " AND active = 1";
      }
      if($active == 0) {
        $where .= " AND active = 0";
      }
    }
    
    if(array_key_exists("create_by", $filter)) {
      $create_by = $filter['create_by'];
      if(is_numeric($create_by)) {
        $where .= " AND create_by=$create_by";
      }
    }
    
    if(array_key_exists("name", $filter)) {
      $name = FronkDB::singleton()->escape($filter['name']);
      if($name) {
        $where .= " AND name='$name'";
      }
    }
    
    if(array_key_exists("object_type", $filter)) {
      $otype = $filter['object_type'];
      if(strtolower($otype) == "building") {
        $where .= " AND object_type='Building'";
      }
      if(strtolower($otype) == "termination") {
        $where .= " AND object_type='Termination'";
      }
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}